<!-- eslint-disable vue/multi-word-component-names -->
<template>
  <a-layout class="menu">
    <a-layout-header
      class="menu_header"
      :style="{ backgroundColor: themeColor }"
    >
      <a-switch
        :checked="theme === 'dark'"
        checked-children="Dark"
        un-checked-children="Light"
        @change="changeTheme"
      />
      <div class="menu_header-item">{{ setUserName }}</div>
      <div class="menu_header-item">{{ setLanguage }}</div>
    </a-layout-header>
    <br />
    <a-layout>
      <a-layout-sider class="menu_side" width="200">
        <a-menu
          mode="inline"
          :theme="theme"
          :defaultSelectedKeys="['1']"
          :style="{ height: '100%', borderRight: 0 }"
        >
          <a-menu-item key="dashboard">
            <template #icon>
              <TableOutlined />
            </template>
            <router-link to="/dashboardView">{{
              $t("menu.dashboard")
            }}</router-link>
          </a-menu-item>
          <a-menu-item key="todos">
            <template #icon>
              <BarsOutlined />
            </template>
            <router-link to="/todos">{{ $t("menu.todos") }}</router-link>
          </a-menu-item>
          <a-menu-item key="weather">
            <template #icon>
              <CloudOutlined />
            </template>
            <router-link to="/weatherView">{{
              $t("menu.weather")
            }}</router-link>
          </a-menu-item>
          <a-menu-item key="profile">
            <template #icon><TeamOutlined /> </template>
            <router-link to="/profileView">{{
              $t("menu.profile")
            }}</router-link>
          </a-menu-item>
        </a-menu>
      </a-layout-sider>
      <a-layout>
        <a-layout-content
          class="menu_content"
          :style="{
            padding: '24px',
            margin: 0,
            minHeight: '85vh',
          }"
        >
          <router-view />
        </a-layout-content>
      </a-layout>
    </a-layout>
  </a-layout>
</template>

<script lang="ts">
import { defineComponent, reactive, toRefs, watch } from "vue";
import {
  TeamOutlined,
  BarsOutlined,
  CloudOutlined,
  TableOutlined,
} from "@ant-design/icons-vue";
import { theme, type MenuTheme } from "ant-design-vue";
import { ref } from "vue";
import store from "@/store";

export default defineComponent({
  components: {
    BarsOutlined,
    CloudOutlined,
    TeamOutlined,
    TableOutlined,
  },
  setup() {
    const todosData =
      JSON.parse(localStorage.getItem("userName") ?? "[]") || "";
    const userName = ref(todosData);

    const languageData =
      JSON.parse(localStorage.getItem("language") ?? "[]") || "";
    const language = ref(languageData);

    let defaultStore = store.state.them;
    const state = reactive({
      theme: defaultStore as MenuTheme,
      selectedKeys: ["dashboard"],
      themeColor: defaultStore == "dark" ? "#001529" : "white",
      setLanguage: language,
      setUserName: userName,
    });
    const changeTheme = (checked: boolean) => {
      state.theme = checked ? "dark" : "light";
      state.themeColor = checked ? "#001529" : "white";
    };

    watch(
      () => store.state.them,
      function () {
        console.log("value changes detected");
        state.theme = store.state.them;
        state.themeColor = store.state.them == "dark" ? "#001529" : "white";
      }
    );
    watch(
      () => store.state.language,
      function (newValue, oldValue) {
        if (newValue != oldValue) state.setLanguage = store.state.language;
      }
    );
    watch(
      () => store.state.userName,
      function () {
        state.setUserName = store.state.userName;
      }
    );

    return {
      ...toRefs(state),
      changeTheme,
      userName,
      language,
    };
  },
});
</script>

<style lang="scss">
.menu {
  &_header {
    display: flex;
    align-items: center;
    justify-content: space-around;

    &-item {
      padding: 8px 16px;
      font-size: 16px;
      line-height: 16px;
      height: fit-content;
      background-color: rgb(59 130 246 / 0.5);
      border-radius: 6px;
    }
  }

  &_content {
    display: flex;
    align-items: center;
    justify-content: center;
  }

  &_input {
    width: 100px !important;
  }
}
</style>
